#include "user.h"
#include "i2c.h"
#include"tic120.h"

#include <math.h>

volatile unsigned char i,del;
unsigned char sens=1,k=0;

unsigned int adc_res1[0xff],max_arr,min_arr;
unsigned int adc_der,acs_der,ind_der,tmp;
unsigned int lev=1650;
unsigned long avr_arr;


static void avr_init(void);


ISR(TIMER0_OVF_vect) //   
{
//------------------------------------
	i++;
	adc_res1[i]=res_ADC();
	
	if (i==0xff)
	{
		i=0;
		TIMSK=0b00000100;
	}
	
	return;
}



ISR(TIMER1_OVF_vect) //   
{
	del++;
	
	if(del==2)
	{
		del=0;
		/*
		//-------------------------------
		
		for(unsigned char j=0x01;j<0xff;j++)
		{
			avr_arr=avr_arr+adc_res1[j];
		}
		avr_arr=avr_arr/0xfe;
		*/
		
		//------------ --------------------
		max_arr=adc_res1[1];
		for(unsigned char j=0x00;j<0xff;j++)
		{
			if(max_arr<=adc_res1[j])	max_arr=adc_res1[j];
		}	
		
		//------------------- ------------------
		min_arr=adc_res1[1];
		
		for(unsigned char j=0x01;j<0xff;j++)
		{
			if(min_arr>=adc_res1[j])	min_arr=adc_res1[j];
		}
		
		//------------------------------------------
		if (max_arr<lev)
		{
			tic120_put_str(0, 0, "-");
			tic120_put_str(30, 0, "-");
		}
		else
		{
			tic120_put_str(0, 0, "+");
			tic120_put_str(30, 0, "+");
		}
		
		//tic120_3_dig_small_p(6,0,(33*abs(max_arr-lev))/10);
		tic120_3_dig_small_p(6,0,(33*abs(min_arr-lev))/10);
		tic120_3_dig_small_p(36,0,(33*abs(max_arr-min_arr))/10);
		
		
	}
	
	//---------------------------------------
	ind_der=((33*abs(max_arr-min_arr))/10)/sens; 
	if (ind_der>63)		ind_der=63;
	
	for(unsigned char a=1; a<tmp; a++)
	{
		tic120_set_addr_RAM(a,2);
		tic120_data_send(0x00);
		//pause(5);
	}
	tmp=0;
	for(unsigned char a=0; a<ind_der; a++)
	{
		tic120_set_addr_RAM(a,2);
		tic120_data_send(0xff);
		pause(10);
	}
	tmp=ind_der;
	
	
	
	TIMSK=0b00000000;
	return;
}



	

int main (void) 

{	
	avr_init();
	
	lev=eeprom_read_word(0x02);
	
	k=eeprom_read_word(0x01);
	
// LCD
	tic120_start_conf ();
	tic120_set_RAM_config(x_addr);
	tic120_data_clear_screen();
	tic120_set_addr_RAM(0,0);

	tic120_set_addr_RAM(0,1);
	tic120_data_send(0xc0);
	tic120_set_addr_RAM(0,2);
	tic120_data_send(0xff);
	tic120_set_addr_RAM(0,3);
	tic120_data_send(0x03);
	
	
	
	if (k==0)	
	{
		sens=2;
		tic120_put_str(58, 0, "h");
	}
	if (k==1)
	{
		sens=4;
		tic120_put_str(58, 0, "m");
	}
	if (k==2)
	{		
		sens=8;
		tic120_put_str(58, 0, "l");
	}

	
	sei();

	for(;;)
	{
		if (((keyC(PC0))==0)&&((keyC(PC2))==0))
		{
			cli();
			tic120_put_str(38, 3, "auto");
			
			lev=0;
			eeprom_write_word(0x02,lev);
			
			pause(400);
			tic120_put_str(38, 3, "    ");
			sei();
		}
//-----------------------------------------------------
		if ((keyC(PC0))==0) // right
		{	
			///*
			cli();
			k++;
			if(k>2) k=0;
			eeprom_write_word(0x01,k);
			
			if (k==0)	
			{
				sens=2;
				tic120_put_str(58, 0, "h");
			}
			if (k==1)
			{
				sens=4;
				tic120_put_str(58, 0, "m");
			}
			if(k==2)
			{		
				sens=8;
				tic120_put_str(58, 0, "l");
			}
			
			sei();
			//*/
			
		}
//-----------------------------------------------------
		if ((keyC(PC1))==0) // center
		{
			
		}
//-----------------------------------------------------
		if ((keyC(PC2))==0) // left
		{
			cli();
			tic120_put_str(38, 3, "adj");
			
			lev=res_ADC();
			eeprom_write_word(0x02,lev);
			
			pause(400);
			tic120_put_str(38, 3, "   ");
			sei();	
		}
		
		
		TIMSK=0b00000001;
	}
}

static void avr_init(void)
{
// 

	PORTC=0b00000111;
	DDRC =0b00001000;
	
//
	PORTD=0b11111111;
	DDRD =0b11111111;
	
	PORTB=0b11111111;
	DDRB =0b11111111;
	
//  

	//GICR= 0b01000000;
	//MCUCR=0b00001111;
	//GICR=0b10000000;

// 
	TIMSK=0b00000001;
	
	TCCR0=0b00000010; //  clk/8; clk= 16MHz
	//TCCR0=0b00000010; //  clk/64; clk= 16MHz
	//TCCR0=0b00000101; //  clk/256; clk= 16MHz
	
	//OCR0=0x7d;
	

	TCCR2 = 0b01101001; 	// FAst PWM 
	OCR2 = 0x24;			//    OC2 (16 )
	//TCNT2= 0x00;			//   


	TCCR1A=0b00000000;
	TCCR1B=0b00000010;
	
	//ICR1=0xff; ///  T1
	//OCR1A=0xaa;
	
//  UART
	//UBRRL = 0x4e;	//     (9600,8,1,no event)
	//UBRRH = 0x00;						
	
//     USART 
///	UCSRA = 0b00000001;		
	//UCSRC = 0b10000110;					
//	UCSRB = 0b10011000;	
	
	//  
	// ADMUX:  10 , Vref=AVCC, -6 (ADC6)
	ADMUX &= 0xDF & 0x7F & 0xF1; ADMUX |= 0x40 | 0x06;   
	// ADCSRA: . ,  , F=125 =19,
	ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x40 | 0x20 | 0x03; 				
    return;
}

/*
void scale_ind (void)
{

	tic120_set_addr_RAM(31,1);
	tic120_data_send(0xff);
	
	tic120_set_addr_RAM(32,1);
	tic120_data_send(0xff);
	
	tic120_set_addr_RAM(31,2);
	tic120_data_send(0xff);
	
	tic120_set_addr_RAM(32,2);
	tic120_data_send(0xff);
	
	tic120_set_addr_RAM(31,3);
	tic120_data_send(0xff);

	tic120_set_addr_RAM(32,3);
	tic120_data_send(0xff);
	
	tic120_set_addr_RAM(33,1);
	tic120_data_send(0xff);

	tic120_set_addr_RAM(33,3);
	tic120_data_send(0xff);
}

void zero_max_val (void)
{

	tic120_set_addr_RAM((acs_max/2)+1,1);
	tic120_data_send(0x00);
	tic120_set_addr_RAM((acs_max/2)+1,2);
	tic120_data_send(0x0);
	tic120_set_addr_RAM((acs_max/2)+1,3);
	tic120_data_send(0x00);
	
	tic120_set_addr_RAM((acs_max/8)+1,1);
	tic120_data_send(0x00);
	tic120_set_addr_RAM((acs_max/8)+1,2);
	tic120_data_send(0x0);
	tic120_set_addr_RAM((acs_max/8)+1,3);
	tic120_data_send(0x00);
	
	tic120_set_addr_RAM((acs_max/16)+1,1);
	tic120_data_send(0x00);
	tic120_set_addr_RAM((acs_max/16)+1,2);
	tic120_data_send(0x0);
	tic120_set_addr_RAM((acs_max/16)+1,3);
	tic120_data_send(0x00);

	acs_max=0;
}
*/