#include"tic120.h"
#include"user.h"
#include"i2c.h"

void tic120_set_RAM_config(unsigned char addressing)
{
		// 
		i2c_start();
		i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
		i2c_ack();
		
		// control byte
		i2c_write_byte(0b10000000);
		i2c_ack();
//################################################################
		//     
		i2c_write_byte(0b00000001);
		i2c_ack();
		
		// control byte
		i2c_write_byte(0b00000000);
		i2c_ack();
	
	if(addressing==0)
	{
		
		//      sleep
		// PD=0; V=0
		i2c_write_byte(0b00100000);
		i2c_ack();
	}
	else
	{
		
		//      sleep
		// PD=0; V=1
		i2c_write_byte(0b00100010);
		i2c_ack();
		
	}
	
	// control byte
	i2c_stop();
	return;
}

void tic120_set_screen_config(unsigned char D, unsigned char IM, unsigned char E)
{

	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();	
	
	//################################################################
	//    
	i2c_write_byte(0b00001001);
	i2c_ack();
		
	// control byte  
	i2c_write_byte(0b00000000);
	i2c_ack();
	
	//  
	if ((D==1)&&(IM==0)&&(E==0))	i2c_write_byte(0b00001100);
	if ((D==1)&&(IM==1)&&(E==0))	i2c_write_byte(0b00001110);	
	if ((D==1)&&(IM==1)&&(E==1))	i2c_write_byte(0b00001111);
	if ((D==1)&&(IM==0)&&(E==1))	i2c_write_byte(0b00001101);
	
	if ((D==0)&&(IM==0)&&(E==0))	i2c_write_byte(0b00001000);
	if ((D==0)&&(IM==1)&&(E==0))	i2c_write_byte(0b00001010);
	if ((D==0)&&(IM==0)&&(E==1))	i2c_write_byte(0b00001001);
	if ((D==0)&&(IM==1)&&(E==1))	i2c_write_byte(0b00001011);
	i2c_ack();

	i2c_stop();

	return;
}

void tic120_set_mux_config(unsigned char mux_rate)
{
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
	
	// last conr byte
	i2c_write_byte(0b00000000);
	i2c_ack();
	
	// MUX rate
	
	switch (mux_rate)
	{
		case 0: // 1/17
			i2c_write_byte(0b00000100);
			break;
		case 1: // 1/26
			i2c_write_byte(0b00000110);
			break;
		case 2: //	1/34
			i2c_write_byte(0b00000101);
			break;
		default:
			break;
	}
	
	i2c_ack();
	i2c_stop();
}

void tic120_set_HV(unsigned char HV_level,unsigned char HV_mul, 
unsigned char HVE_on_off,unsigned char PRS_on_off,unsigned char temperature)
{
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
	
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	//################################################################
	//       
	i2c_write_byte(0b00000001);
	i2c_ack();

	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	//  HV-gen
	i2c_write_byte(0b00001010);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	//  
	switch (temperature)
	{
		case 0: // TC0
			i2c_write_byte(0b00001000);
			break;
		case 1: // TC1
			i2c_write_byte(0b00001001);
			break;
		case 2: //	TC2
			i2c_write_byte(0b00001010);
			break;
		case 3: //	TC3
			i2c_write_byte(0b00001011);
			break;
		default:
			break;
	}
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
		
	//   
	switch (HV_mul)
	{
		case 0: // 2 x voltage multiplier
			i2c_write_byte(0b00100000);
			break;
		case 1: // 3 x voltage multiplier
			i2c_write_byte(0b00100001);
			break;
		case 2: //	4 x voltage multiplier
			i2c_write_byte(0b00100010);
			break;
		case 3: //	5 x voltage multiplier
			i2c_write_byte(0b00100011);
			break;
		case 4: //	5 x voltage multiplier
			i2c_write_byte(0b00100100);
			break;
		case 5: //	5 x voltage multiplier
			i2c_write_byte(0b00100101);
			break;
		case 6: //	5 x voltage multiplier
			i2c_write_byte(0b00100110);
			break;
		case 7: //	5 x voltage multiplier
			i2c_write_byte(0b00100111);
			break;
		default:
			break;
	}
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
		
	// V_LCD: //PRS=0(  ); HVE=1 ()
	// V_lcd~5.6
	if ((PRS_on_off==0)&&(HVE_on_off==0))	i2c_write_byte(0b00000100);
	if ((PRS_on_off==1)&&(HVE_on_off==0))	i2c_write_byte(0b00000110);
	if ((PRS_on_off==0)&&(HVE_on_off==1))	i2c_write_byte(0b00000101);
	if ((PRS_on_off==1)&&(HVE_on_off==1))	i2c_write_byte(0b00000111);
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
		
	//    
	//i2c_write_byte(0b11000000);
	switch (HV_level)
	{
		case 0: // 2 x voltage multiplier
			i2c_write_byte(0b10000001);
			break;
		case 1: // 3 x voltage multiplier
			i2c_write_byte(0b10000010);
			break;
		case 2: //	4 x voltage multiplier
			i2c_write_byte(0b10000100);
			break;
		case 3: //	5 x voltage multiplier
			i2c_write_byte(0b10001000);
			break;
		case 4: //	5 x voltage multiplier
			i2c_write_byte(0b10010000);
			break;
		case 5: //	5 x voltage multiplier
			i2c_write_byte(0b10100000);
			break;
		case 6: //	5 x voltage multiplier
			i2c_write_byte(0b11000000);
			break;
		default:
			break;
	}
	i2c_ack();
	
	i2c_stop();
	return;
}

void	tic120_start_conf (void)
{
// 
	tic120_rst();
	
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// RAM command page H=00
	i2c_write_byte(0b00000001);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();

	// function and RAM command page PD=0, V=1
	i2c_write_byte(0b00100010);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();

	// select disp settings H=01
	
	i2c_write_byte(0b00001001);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// set notmal D=1, IM=0, E=0
	i2c_write_byte(0b00001100);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// set Mux rate 1:34
	i2c_write_byte(0b00000101);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// RAM command page H=00
	i2c_write_byte(0b00000001);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// select HV-gen page H=10
	i2c_write_byte(0b00001010);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();

	// set volt multiplication S
	i2c_write_byte(0b000010000);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// set temperature coef TC
	i2c_write_byte(0b00100000);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// set Vlcd prs=1 hve=1
	i2c_write_byte(0b00000101);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	
	// set Vlcd - !!!
	i2c_write_byte(0b11011110);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b10000000);
	i2c_ack();
	// 
}

void tic120_data_clear_screen(void)
{
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
	
	i2c_write_byte(0b01000000);
	i2c_ack();	
//##############################   ##########
	//  
	for (unsigned int i=0;i<649;i++)
	{
		i2c_write_byte(0x00);
		i2c_ack();
	}
	i2c_stop();
	
	return;
}
void tic120_data_send(unsigned char data)
{
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
	
	i2c_write_byte(0b01000000);
	i2c_ack();	

	i2c_write_byte(data);
	i2c_ack();

	i2c_stop();
	
	return;
}

void tic120_set_addr_RAM(unsigned char x,unsigned char y)
{
	// 
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
//################################################################
	//     
	i2c_write_byte(0b00000001);
	i2c_ack();
	
	i2c_write_byte(0b00000000);
	i2c_ack();
		
	i2c_write_byte(0b01000000|(0b00000111&y));
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
		
	i2c_write_byte(0b10000000|(0b01111111&x));
	i2c_ack();
	i2c_stop();
	
	return;
}

void tic120_set_addr_RAM_x(unsigned char x)
{
	// 
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
//################################################################
	//     
	i2c_write_byte(0b00000001);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
	
	i2c_write_byte(0b10000000|(0b01111111&x));
	i2c_ack();
	i2c_stop();
	
	return;
}

void tic120_set_addr_RAM_y(unsigned char y)
{
	// 
	i2c_start();
	i2c_write_byte(0b01111000);// sa0=0!; r/w=0!
	i2c_ack();
		
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
//################################################################
	//     
	i2c_write_byte(0b00000001);
	i2c_ack();
	
	// control byte
	i2c_write_byte(0b00000000);
	i2c_ack();
		
	i2c_write_byte(0b01000000|(0b00000111&y));
	i2c_ack();
	
	i2c_stop();
	
	return;
}

//------------------------------------------------------------------
void tic120_rst (void)
{
	PORTC&=~_BV(tic120_res);
	pause(50);
	PORTC|=_BV(tic120_res);
	return;
}


// --------------------------graph------------------------------------------------------
void tic120_set_dot (unsigned char x,unsigned char y)
{
	unsigned char tmp=0;
	
	tic120_set_addr_RAM(x,y/8);
	tic120_data_send(tmp | (1 << (y % 8)));
	return;
}	

void tic120_WriteChar_small(unsigned char x,unsigned char y,unsigned char c)
{
	tic120_set_addr_RAM(x,y);
	unsigned char i = 0;
	for(i=0; i<5; i++)
	{
		tic120_data_send(pgm_read_byte(&Font5x7[((c - 0x20) * 5) + i]));
	}
}
	

void tic120_WriteChar_big(unsigned char x,unsigned char dig) //32x16
{
	//unsigned char tmp=0;
	for(unsigned char j=0; j<4; j=j+1)
	{
		tic120_set_addr_RAM(x,j);
		for(unsigned char i=0; i<16; i++)
		{
			//tic120_data_send(pgm_read_byte(&Font_tr_32x16[(dig*64)+i+(j*16)]));
			tic120_data_send(pgm_read_byte(&Font_32x16[(dig*64)+i+(j*16)]));
		}
	}
}


void tic120_charge_monitor(unsigned char x,unsigned char c)
{
	//unsigned char tmp=0;
	for(unsigned char j=0; j<4; j++)
	{
		tic120_set_addr_RAM(x,3-j);
		for(unsigned char i=0; i<8; i++)
		{
			tic120_data_send(pgm_read_byte(&charge_monitor[(c*32)+i+(j*8)]));
		}
	}
}

void tic120_2_dig_big(unsigned char x, unsigned char val)
{
	tic120_WriteChar_big(x,val/10);
	tic120_WriteChar_big(x+18,val%10);
	return;
}

void tic120_2_dig_big_adv(unsigned char x, unsigned char val)
{
	if (val/10==0)	tic120_WriteChar_big(x,13);
	else tic120_WriteChar_big(x,val/10);
	tic120_WriteChar_big(x+18,val%10);
	return;
}

void tic120_2_dig_small(unsigned char x,unsigned char y, unsigned char val)
{
	tic120_WriteChar_small(x,y,val/10+0x30);
	tic120_WriteChar_small(x+6,y,val%10+0x30);
	return;
}

void tic120_2_dig_small_adv(unsigned char x,unsigned char y, unsigned char val)
{
	if (val/10==0)	tic120_WriteChar_small(x,y,0x00);
	else tic120_WriteChar_small(x,y,val/10+0x30);
	tic120_WriteChar_small(x+6,y,val%10+0x30);
	return;
}

void tic120_put_str(unsigned char x, unsigned char y, unsigned char txt[])
{
	tic120_set_addr_RAM(x,y);
	unsigned char i=0;
	while (txt[i]!=0)
	{
		tic120_WriteChar_small(x+i*6,y,txt[i]);
		i++;
	}
	return;
}


void tic120_4_dig_small(unsigned char x,unsigned char y, unsigned int val)
{
	tic120_WriteChar_small(x,y,val/1000 + 0x30);
	tic120_WriteChar_small(x+6,y,(val/100)%10 + 0x30);
	tic120_WriteChar_small(x+12,y,(val/10)%10 + 0x30);
	tic120_WriteChar_small(x+18,y,val%10+0x30);
	return;
}

void tic120_3_dig_small_p(unsigned char x,unsigned char y, unsigned int val)
{
	//tic120_WriteChar_small(x,y,val/1000 + 0x30);
	tic120_WriteChar_small(x,y,(val/100)%10 + 0x30);
	tic120_set_dot (x+6,y+6);
	tic120_WriteChar_small(x+8,y,(val/10)%10 + 0x30);
	tic120_WriteChar_small(x+14,y,val%10 + 0x30);
	return;
}

void tic120_3_dig_small(unsigned char x,unsigned char y, unsigned int val)
{
	tic120_WriteChar_small(x,y,(val/100)%10 + 0x30);
	tic120_WriteChar_small(x+6,y,(val/10)%10 + 0x30);
	tic120_WriteChar_small(x+12,y,val%10 + 0x30);
	return;
}

void tic120_4_dig_small_p(unsigned char x,unsigned char y, unsigned int val)
{
	tic120_WriteChar_small(x,y,val/1000 + 0x30);
	tic120_WriteChar_small(x+6,y,(val/100)%10 + 0x30);
	//tic120_WriteChar_small(x+12,y,14);
	tic120_set_dot (x+12,y+6);
	tic120_WriteChar_small(x+12,y,(val/10)%10 + 0x30);
	tic120_WriteChar_small(x+18,y,val%10 + 0x30);
	return;
}

void tic120_4_dig_big(unsigned int x,unsigned int val)
{
	tic120_WriteChar_big(x,val/1000);
	tic120_WriteChar_big(x+18,(val/100)%10);
	tic120_WriteChar_big(x+36,(val/10)%10);
	tic120_WriteChar_big(x+54,val%10);
	return;
}
void tic120_clrscr(void)
{
	tic120_set_addr_RAM(0,0);
	for (unsigned char i=0;i<118;i++)	tic120_data_send(0x00);
	tic120_set_addr_RAM(0,1);
	for (unsigned char i=0;i<118;i++)	tic120_data_send(0x00);
	tic120_set_addr_RAM(0,2);
	for (unsigned char i=0;i<118;i++)	tic120_data_send(0x00);
	tic120_set_addr_RAM(0,3);
	for (unsigned char i=0;i<118;i++)	tic120_data_send(0x00);
	
	return;
}
