#include <avr/io.h>             // -
#include <util/delay.h>     //   

#include "i2c.h"
#include"Font32x16.h"
#include"font5x7.h"

#define tic120_res	PC3
#define tic120	0b01111000


#define x_addr	0
#define y_addr	1
#define on		1
#define off		0


void tic120_set_RAM_config(unsigned char addressing);
void tic120_set_screen_config(unsigned char D, unsigned char IM, unsigned char E);
void tic120_set_mux_config(unsigned char mux_rate);

void tic120_set_HV(unsigned char HV_level,unsigned char HV_mul, 
unsigned char HVE_on_off,unsigned char PRS_on_off,unsigned char temperature);
void tic120_data_clear_screen(void);
void tic120_data_send(unsigned char data);
void tic120_set_addr_RAM(unsigned char x,unsigned char y);
void tic120_set_addr_RAM_y(unsigned char y);
void tic120_set_addr_RAM_x(unsigned char x);

void tic120_rst (void);


void tic120_set_dot (unsigned char x,unsigned char y);

void tic120_WriteChar_small(unsigned char x,unsigned char y,unsigned char c); // 8x5
void tic120_WriteChar_big(unsigned char x,unsigned char dig); //32x16
void tic120_charge_monitor(unsigned char x,unsigned char c);
void tic120_put_str(unsigned char x, unsigned char y, unsigned char *val);
void	tic120_start_conf (void);

void tic120_2_dig_small(unsigned char x,unsigned char y, unsigned char val);
void tic120_2_dig_big(unsigned char x, unsigned char val);
void tic120_2_dig_small_adv(unsigned char x,unsigned char y, unsigned char val);
void tic120_2_dig_big_adv(unsigned char x, unsigned char val);
void tic120_4_dig_small(unsigned char x,unsigned char y, unsigned int val);
void tic120_4_dig_small_p(unsigned char x,unsigned char y, unsigned int val);
void tic120_3_dig_small_p(unsigned char x,unsigned char y, unsigned int val);
void tic120_3_dig_small(unsigned char x,unsigned char y, unsigned int val);
void tic120_4_dig_big(unsigned int x,unsigned int val);
void tic120_clrscr(void);



